VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DInput_Joystick"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' VISUAL BASIC WORLD
' ===========================================
' Das groe Portal zum Thema Visual Basic.
'
' Wenn Ihnen dieser Source Code gefallen hat,
' dann empfehlen Sie Visual Basic World bitte
' weiter und/oder setzen Sie einen Link auf:
'
' http://www.visualbasicworld.de/
'
' Vernetzen Sie sich mit uns:
'
' http://twitter.com/visualbasicwrld
'
' Autor: Thomas Geiger

'Diese Klasse wird fr die Joystickuntersttzung bentigt

Dim DirectX As DirectX7
Dim DInput As DirectInput
Dim DInputDevice As DirectInputDevice
Dim DInputDeviceEnum As DirectInputEnumDevices
Dim JoyState As DIJOYSTATE

Dim Joy_Up As Boolean
Dim Joy_Down As Boolean
Dim Joy_Left  As Boolean
Dim Joy_Right As Boolean
Function GetJoysticksCount()

   GetJoysticksCount = DInputDeviceEnum.GetCount

End Function
Function GetJoystickName(ByVal JoyNumb As Integer)

On Error GoTo funcerr
   GetJoystickName = DInputDeviceEnum.GetItem(JoyNumb).GetInstanceName

Exit Function

funcerr:
GetJoystickName = "###Error###"

End Function
Function GetJoystickAddress(ByVal JoyNumb As Integer)

On Error GoTo funcerr
   GetJoystickAddress = DInputDeviceEnum.GetItem(JoyNumb).GetGuidInstance

Exit Function
funcerr:
GetJoystickAddress = "###Error###"

End Function
Function ConnectToJoystick(Form_Val As Form, ByVal JoyAddress As String)

Set DInputDevice = DInput.CreateDevice(JoyAddress)
DInputDevice.SetCommonDataFormat DIFORMAT_JOYSTICK
DInputDevice.SetCooperativeLevel Form_Val.hWnd, DISCL_BACKGROUND Or DISCL_NONEXCLUSIVE
DInputDevice.Acquire

'Achsen neu konfigurieren
Dim DiProp_Range As DIPROPRANGE

With DiProp_Range
    .lHow = DIPH_DEVICE
    .lSize = Len(DiProp_Range)
    .lMin = 0
    .lMax = 5000
End With

DInputDevice.SetProperty "DIPROP_RANGE", DiProp_Range

'Deadzone neu konfigurieren
Dim DiProp_Dead As DIPROPLONG

With DiProp_Dead
    .lData = 1000
    .lSize = Len(DiProp_Dead)
    .lHow = DIPH_BYOFFSET
    .lObj = DIJOFS_X
    DInputDevice.SetProperty "DIPROP_DEADZONE", DiProp_Dead
    .lObj = DIJOFS_Y
    DInputDevice.SetProperty "DIPROP_DEADZONE", DiProp_Dead
End With

   DInputDevice.Poll

End Function
Function GetJoyState()

DInputDevice.Poll
DInputDevice.GetDeviceStateJoystick JoyState

If JoyState.y = 2500 Then
Joy_Up = False
Joy_Down = False
Else
Joy_Up = False
Joy_Down = False
  If JoyState.y > 2500 Then
  Joy_Down = True
  Else
  Joy_Up = True
  End If
End If

If JoyState.x = 2500 Then
Joy_Left = False
Joy_Right = False
Else
Joy_Left = False
Joy_Right = False
  If JoyState.x > 2500 Then
  Joy_Right = True
  Else
  Joy_Left = True
  End If
End If

End Function
Private Sub Class_Initialize()

Set DirectX = New DirectX7
Set DInput = DirectX.DirectInputCreate()
Set DInputDeviceEnum = DInput.GetDIEnumDevices(DIDEVTYPE_JOYSTICK, DIEDFL_ATTACHEDONLY)

End Sub
Public Property Get JoyState_Up() As Boolean
   JoyState_Up = Joy_Up
End Property
Public Property Let JoyState_Up(ByVal vNewValue As Boolean)
End Property
Public Property Get JoyState_Down() As Boolean
   JoyState_Down = Joy_Down
End Property
Public Property Let JoyState_Down(ByVal vNewValue As Boolean)
End Property
Public Property Get JoyState_Left() As Boolean
   JoyState_Left = Joy_Left
End Property
Public Property Let JoyState_Left(ByVal vNewValue As Boolean)
End Property
Public Property Get JoyState_Right() As Boolean
   JoyState_Right = Joy_Right
End Property
Public Property Let JoyState_Right(ByVal vNewValue As Boolean)
End Property
